%define sendmailcf %{_datadir}/sendmail-cf
%define smshell /sbin/nologin
%define spooldir %{_localstatedir}/spool
%define maildir %{_sysconfdir}/mail

%define enable_pie yes

Summary: Sendmail Mail Transport Agent
Summary(ko): Sendmail 메일 전송 에이전트
Name: sendmail
Version: 8.15.2
Release: 1%{?dist}
Epoch: 100
License: BSD
Group: System Environment/Daemons
Source0: ftp://ftp.sendmail.org/pub/sendmail/sendmail.%{version}.tar.gz
Source1: sendmail.init
Source2: conf.access
Source3: conf.aliases
Source4: sendmail.sysconfig
Source5: sendmail-etc-mail-Makefile
Source6: sendmail-annyung.mc
Source7: conf.virtuser
Source9: mapupdate
Source10: additional_cf.patch
Source11: Sendmail.conf
Source12: conf.domaintable
Source13: conf.mailertable
Source14: conf.smtpauth
Source15: sendmail.pam
Source16: vaclook
Source17: vaclook.man
Source18: vaclook.man.ko
Source19: vacation.man.ko
Source20: additional_submit_cf.patch
Source21: milter-functions
Source22: conf.trusted-users
Source23: sendmail.service
Source100: cert.sh
Source101: utils-po.tar.bz2
Patch0: sendmail-redhat.patch
Patch1: sendmail-cf.patch
Patch2: sendmail-makemapman.patch
Patch3: sendmail-smrsh.patch
Patch4: sendmail-db1.patch
Patch5: sendmail-rmail.patch
Patch6: sendmail-owner.patch
Patch7: sendmail-pid.patch
Patch8: sendmail-smmsp.patch
Patch9: sendmail-8.14.4-sasl2-in-etc.patch
Patch10: sendmail-8.14.3-sharedmilter.patch
Patch11: sendmail-localdomain.patch
Patch12: sendmail-dynamic.patch
Patch13: sendmail-switchfile.patch

# AnNyung Linux Kernel Release problem patch (one more follow line)
Patch100: sendmail-release.patch

Provides: smtpdaemon
Provides: MTA smtpdaemon server(smtp)
Provides: %{_sbindir}/sendmail %{_bindir}/mailq %{_bindir}/newaliases
#Provides: %{_bindir}/rmail /usr/lib/sendmail
Provides: /usr/lib/sendmail
Provides: %{_sysconfdir}/pam.d/smtp
Provides: %{_mandir}/man1/mailq.1.gz %{_mandir}/man1/newaliases.1.gz
Provides: %{_mandir}/man5/aliases.5.gz %{_mandir}/man8/sendmail.8.gz

%define _unpackaged_files_terminate_build 0
%global _is_milter 1
%global _is_tls 1

%{!?_is_milter:%global with_milter 0}
%{?_is_milter:%global with_milter 1}
%{!?_is_tls:%global with_tls 0}
%{?_is_tls:%global with_tls 1}

Buildroot: /var/tmp/%{name}-root
Requires(pre): shadow-utils
Requires(preun): %{_sbindir}/alternatives chkconfig
Requires(post): %{_sbindir}/alternatives chkconfig coreutils
Requires(postun): %{_sbindir}/alternatives coreutils
Requires: cyrus-sasl-plain openssl procmail
BuildRequires: cyrus-sasl-devel openssl-devel chkconfig db4-devel m4 gettext

%description
The Sendmail program is a very widely used Mail Transport Agent (MTA).
MTAs send mail from one machine to another. Sendmail is not a client
program, which you use to read your e-mail. Sendmail is a
behind-the-scenes program which actually moves your e-mail over
networks or the Internet to where you want it to go.

If you ever need to reconfigure Sendmail, you'll also need to have the
sendmail.cf package installed.  If you need documentation on Sendmail,
you can install the sendmail-doc package.

This package supports SMTP AUTH and requires the CMU SASL library.
Auth mechanisms supported include PLAIN, CRAM-MD5, DIGEST-MD5 and LOGIN
(LOGIN is used by Microsoft mail clients including Outlook and Outlook
Express).

%description -l ko
Sendamil program은 널리 사용이 되어지는 Mail 전송 프로그램이다(MTA).
Mail 전송 프로그램들은 어떠한 machine에서 다른 machine으로 메일을 보내
며 Sendmail은 e-mail을 읽이 위해 사용하는 client program은 아니다.
Sendamil은 원하는 곳으로 Internet이나 Network를 통해 e-mail을 보내는
역할을 하는 backgrond에서 작업을 하는 프로그램이다.

이 Package는 SMTP 인증을 지원하며 CMU SASL library를 필요로 한다.
인증 매커니즘은 PLAIN, CRAN-MD5, LOGIN을 지원한다.(LOGIN은 Outlokk 과
Outlook Express를 포함하는 Microsoft mail client에 의해 사용된다)

%package doc
Summary: Documentation about the Sendmail Mail Transport Agent program.
Summary(ko): Sendmail 전송 프로그램에 대한 문서
Group: Documentation
BuildArch: noarch

%description doc
The sendmail-doc package contains documentation about the Sendmail
Mail Transport Agent (MTA) program, including release notes, the
Sendmail FAQ and a few papers written about Sendmail.  The papers are
provided in PostScript(TM) and troff formats.

Install the sendmail-doc package if you need documentation about
Sendmail.

%description doc -l ko
sendmail-doc package는 release note들, Sendmail FAQ 그리고 sendmail에
대해 쓰여진 몇몇의 문서들이 포함된 Sendmail MTA(메일 전송 Agent)에 대한
문서를 포함하고 있다. 문서들은 PostScript(TM)과 troff 형식들로 제공이
된다.

%package devel
Summary: Extra development include files and development files with sendmail.
Summary(ko): sendmail 관련 개발을 위한 include 및 라이브러리
Group: System Environment/Libraries
Requires: sendmail-milter

%description devel
Include files and devel libraries for e.g. the milter addons as part
of sendmail.

%description devel -l ko
sendmail 의 개발에 필요한 헤더 파일 및 라이브러리들이 포함되어 있다. 예를 들어
sendmail 의 일부분인 milter 같은 것들이 있다.

%package cf
Summary: The files needed to reconfigure Sendmail.
Summary(ko): Sendmail을 설정하는데 필요한 파일들
Group: System Environment/Daemons
BuildArch: noarch

%description cf
This package includes the configuration files which you'd need to
generate the sendmail.cf file distributed with the sendmail package.
You'll need the sendmail-cf package if you ever need to reconfigure
and rebuild your sendmail.cf file.  For example, the default
sendmail.cf file is not configured for UUCP.  If someday you needed to
send and receive mail over UUCP, you'd need to install the sendmail-cf
package to help you reconfigure Sendmail.

Install the sendmail-cf package if you need to reconfigure your
sendmail.cf file.

%description cf -l ko
이 package는 sendmail.cf를 생성하는데 필요한 설정 file들을 포함하고
있다. sendmail.cf file을 재구성을 하려 한다면 이 package가 필요할 것이
다. 예를 들어 sendmail.cf에 UUCP에 대한 설정이 없을 경우 어느날 갑자기
UUCP를 이용하여 메일을 보내거나 받을 필요가 있을 수도 있게 되는데 이때
sendmail을 재설정하는데 이 package가 필요할 것이다.

%package milter
Summary: The sendmail milter library
Summary(ko): sedmail milter 라이브러리
Group: System Environment/Libraries

%description milter
The sendmail Mail Filter API (Milter) is designed to allow third-party
programs access to mail messages as they are being processed in order to
filter meta-information and content.

This package includes the milter shared library.

%description milter -l ko
sendmail 메일 필터 API (Milter)는 메타 정보와 컨텐츠의 필터를 진행하기
위하여 3-party 프로그램이 메일 메시지에 접근할 수 있도록 설계가 되어있다.

이 패키지는 milter 공유 라이브러리를 포함하고 있다.

%prep
%setup -q -a 101
#%patch100 -p1
%patch0 -p1 -b .orig
%patch1 -p1 -b .orig
%patch2 -p1 -b .orig
%patch3 -p1 -b .orig
%patch5 -p1 -b .orig
%patch6 -p1 -b .orig
#%patch7 -p1 -b .pid
# don't patch for compatible RH6
#patch8 -p1 -b .smmsp
%patch9 -p1
%{__cp} devtools/M4/UNIX/{,shared}library.m4
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1

%{__sed} -e 's|@@PATH@@|\.\.|' < %{SOURCE6} > cf/cf/annyung.mc

#ifarch x86_64
#OPT_FLAGS="%{optflags}"
#else
OPT_FLAGS=`echo %{optflags} | sed 's/-Wp[^ ]*//g'`
#endif

# set up devtools/Site/site.config.m4 so that we link against SASL library
%{__cat} > $RPM_BUILD_DIR/sendmail-%{version}/devtools/Site/site.config.m4 << EOT
APPENDDEF(\`confMAPDEF', \`-DNEWDB -DNIS -DMAP_REGEX -DSOCKETMAP -DNAMED_BIND=1')
APPENDDEF(\`conf_sendmail_ENVDEF', \`${OPT_FLAGS} -I%{_includedir}/db4 -Wall -DXDEBUG=0 -DSASL=2 -DNETINET6 -DHES_GETMAILHOST -D_FFR_SMTP_SSL')dnl
APPENDDEF(\`conf_sendmail_LIBS', \`-lnsl -lsasl2 -ldb -lssl -lcrypt')dnl
APPENDDEF(\`confENVDEF', \`${OPT_FLAGS} -I%{_includedir}/db4 -Wall -DXDEBUG=0 -DSASL=2 -DNETINET6 -DHES_GETMAILHOST -D_FFR_SMTP_SSL')dnl
APPENDDEF(\`confLIBS', \`-lnsl -lcrypt -ldb -lresolv')
APPENDDEF(\`confMANOWN', \`root')
APPENDDEF(\`confMANGRP', \`root')
APPENDDEF(\`confMANMODE', \`644')
APPENDDEF(\`confMAN1SRC', \`1')
APPENDDEF(\`confMAN5SRC', \`5')
APPENDDEF(\`confMAN8SRC', \`8')
APPENDDEF(\`confLIBSEARCH', \`db resolv 44bsd')
EOT

%if "%{enable_pie}" == "yes"
%{__cat} >> $RPM_BUILD_DIR/sendmail-%{version}/devtools/Site/site.config.m4 << EOT
APPENDDEF(\`confOPTIMIZE', \`-fpie')
APPENDDEF(\`confLIBS', \`-pie')
EOT
%endif

%if %{with_milter}
%{__cat} >> $RPM_BUILD_DIR/sendmail-%{version}/devtools/Site/site.config.m4 << EOF
APPENDDEF(\`conf_sendmail_ENVDEF', \`-DMILTER')dnl
APPENDDEF(\`conf_libmilter_ENVDEF', \`-D_FFR_MILTER_ROOT_UNSAFE')dnl
EOF
%endif

%if %{with_tls}
%{__cat} >> $RPM_BUILD_DIR/sendmail-%{version}/devtools/Site/site.config.m4 << EOF
APPENDDEF(\`conf_sendmail_ENVDEF', \`-DSTARTTLS')dnl
APPENDDEF(\`conf_sendmail_LIBS', \`-lssl -lcrypto')dnl
EOF
%endif

%build
targets="mailstats rmail makemap sendmail smrsh vacation praliases"
%{?_is_milter:targets="libmilter $targets"}

for target in $targets
do
  pushd $target
  sh Build
  popd
done

cd cf/cf
%{__cp} annyung.mc config.mc
sh Build config.cf
sh Build annyung.cf


%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/sasl2

%{__install} -m644 %{SOURCE11} %{buildroot}%{_sysconfdir}/sasl2/Sendmail.conf

# create /usr/lib for 64 bit architectures
%if "%{_libdir}" != "/usr/lib"
install -m 755 -d %{buildroot}/usr/lib64
%endif

pushd %{buildroot} > /dev/null 2>&1
%{__mkdir_p} etc/rc.d/init.d etc/rc.d/rc{0,1,2,3,4,5,6}.d etc/sysconfig etc/pam.d
%{__mkdir_p} usr/bin usr/lib usr/sbin var/log/mail var/spool usr/share/sendmail-cf
%{__mkdir_p} usr/share/ssl/certs/sendmail
%{__mkdir_p} %{buildroot}%{_mandir}/man{1,5,8} %{buildroot}%{_mandir}/ko/man1
popd > /dev/null 2>&1

%{__install} -m644 %{SOURCE15} ${RPM_BUILD_ROOT}%{_sysconfdir}/pam.d/smtp.sendmail
#{__install} -m700 %{SOURCE100} ${RPM_BUILD_ROOT}%{_sbindir}/make_sendmail_cert

# OOPS Kernel release problem fix
OBJDIR=obj.$(uname -s).$(uname -r | perl -p -e 's!,.*!!g').$(arch)

targets="mailstats rmail makemap sendmail smrsh vacation praliases "
%{?_is_milter:targets="libmilter $targets"}

nameuser=`id -nu`
namegroup=`id -ng`

Make() {
    %{__make} $@ \
        DESTDIR=%{buildroot} \
        LIBDIR=%{_libdir} \
        MANROOT=%{_mandir}/man \
        LIBMODE=0755 INCMODE=0644 \
        SBINOWN=${nameuser} SBINGRP=${namegroup} \
        UBINOWN=${nameuser} UBINGRP=${namegroup} \
        MANOWN=${nameuser} MANGRP=${namegroup} \
        INCOWN=${nameuser} INCGRP=${namegroup} \
        LIBOWN=${nameuser} LIBGRP=${namegroup} \
        GBINOWN=${nameuser} GBINGRP=${namegroup} \
        CFOWN=${nameuser} CFGRP=${namegroup} \
        CFMODE=0644 MSPQOWN=${nameuser}
}

for target in $targets
do
  Make install -C $OBJDIR/$target
done

ln %{buildroot}%{_sbindir}/makemap %{buildroot}%{_bindir}/makemap

# install the cf files
cd cf
%{__cp} -ar * %{buildroot}%{sendmailcf}/
%{__rm} -f %{buildroot}%{sendmailcf}/*/*.m4path
cd -

%{__install} -m 644 cf/cf/annyung.cf %{buildroot}%{maildir}/sendmail.cf
%{__install} -m 444 cf/cf/submit.cf %{buildroot}%{maildir}/submit.cf
%{__sed} -e 's|@@PATH@@|%{sendmailcf}|' < %{SOURCE6} > \
       %{buildroot}%{maildir}/sendmail.mc
install -p -m 644 cf/cf/submit.mc %{buildroot}%{maildir}/submit.mc
echo "# local-host-names - include all aliases for your machine here." > \
      %{buildroot}%{maildir}/local-host-names

%{__ln_s} -f ../sbin/sendmail.sendmail %{buildroot}/usr/lib/sendmail.sendmail
%{__install} -d -m755 %{buildroot}%{spooldir}/{mqueue,clientmqueue}
# to use multiple queue
%{__install} -d -m755 %{buildroot}%{spooldir}/mqueue/q1
%{__install} -d -m755 %{buildroot}%{spooldir}/mqueue/q2
%{__install} -d -m755 %{buildroot}%{spooldir}/mqueue/q3
%{__install} -d -m755 %{buildroot}%{spooldir}/mqueue/q4
%{__install} -d -m755 %{buildroot}%{spooldir}/mqueue/q5
%{__install} -d -m755 %{buildroot}%{spooldir}/mqueue/q6

# Documentation
%{__install} -d -m755 %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 %{SOURCE7} %{buildroot}%{_docdir}/sendmail-%{version}/README.RPM
%{__install} -m644 doc/op/op.* %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 README %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 devtools/README %{buildroot}%{_docdir}/sendmail-%{version}/README.devtools
%{__install} -m644 devtools/Site/README %{buildroot}%{_docdir}/sendmail-%{version}/README.devtools.Site
%{__install} -m644 mail.local/README %{buildroot}%{_docdir}/sendmail-%{version}/README.mail.local
%{__install} -m644 sendmail/SECURITY %{buildroot}%{_docdir}/sendmail-%{version}/SECURITY

%{__install} -m644 smrsh/README %{buildroot}%{_docdir}/sendmail-%{version}/README.smrsh
%{__install} -m644 sendmail/README %{buildroot}%{_docdir}/sendmail-%{version}/README.sendmail
%{__install} -m644 cf/README %{buildroot}%{_docdir}/sendmail-%{version}/README.cf
%{__install} -m644 contrib/README %{buildroot}%{_docdir}/sendmail-%{version}/README.contrib
%{__install} -m644 FAQ %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 KNOWNBUGS %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 RELEASE_NOTES %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 LICENSE %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 PGPKEYS %{buildroot}%{_docdir}/sendmail-%{version}
%{__install} -m644 INSTALL %{buildroot}%{_docdir}/sendmail-%{version}

%if %{with_milter}
%{__install} -m644 libmilter/README %{buildroot}%{_docdir}/sendmail-%{version}/README.libmilter
%endif

# Development

%{__install} -d -m755 %{buildroot}%{_includedir}/sendmail
%{__install} -m644 include/{libsmdb,sendmail}/*.h %{buildroot}%{_includedir}/sendmail
%if %{with_milter}
%{__install} -m644 include/libmilter/*.h %{buildroot}%{_includedir}/sendmail
%endif

# dangling symlinks
for f in hoststat mailq newaliases purgestat
  do
    %{__ln_s} -f ../sbin/sendmail.sendmail %{buildroot}%{_bindir}/${f}
  done
%{__mkdir_p} %{buildroot}%{_sysconfdir}/smrsh
%{__mkdir_p} %{buildroot}%{_sysconfdir}/mail

(cd %{buildroot}%{_sysconfdir}/smrsh
 ln -sf %{_bindir}/vacation vacation)

%{__install} -m644 %{SOURCE2} %{buildroot}%{maildir}/access
%{__install} -m644 %{SOURCE3} %{buildroot}%{maildir}/aliases
%{__install} -m644 %{SOURCE7} %{buildroot}%{maildir}/virtusertable
%{__install} -m644 %{SOURCE12} %{buildroot}%{maildir}/domaintable
%{__install} -m644 %{SOURCE13} %{buildroot}%{maildir}/mailertable
%{__install} -m644 %{SOURCE14} %{buildroot}%{maildir}/smtpauth
%{__install} -m644 %{SOURCE22} %{buildroot}%{maildir}/trusted-users

for map in virtusertable access domaintable mailertable aliases
do
    %{buildroot}%{_bindir}/makemap -C %{buildroot}%{maildir}/sendmail.cf hash \
    %{buildroot}%{maildir}/${map}.db < %{buildroot}%{maildir}/${map}
    %{__chmod} 0644 %{buildroot}%{maildir}/${map}.db
done

%{__install} -m700 %{SOURCE9} %{buildroot}%{_sbindir}/mapupdate

%{__mkdir} -p %{buildroot}%{_unitdir}
%{__mkdir} -p %{buildroot}%{_sbindir}/init.d

%{__install} -m644 %SOURCE4 %{buildroot}%{_sysconfdir}/sysconfig/sendmail
%{__install} -m755 %SOURCE1 %{buildroot}%{_sbindir}/init.d/sendmail
%{__install} -m644 %SOURCE23 %{buildroot}%{_unitdir}/sendmail.service

%{__install} -m 644 %{SOURCE5} %{buildroot}%{maildir}/Makefile

# manualy vacation utility tool and man page
%{__install} -m755 %{SOURCE16} %{buildroot}%{_bindir}/
%{__install} -m644 %{SOURCE17} %{buildroot}%{_mandir}/man1/vaclook.1
%{__install} -m644 %{SOURCE18} %{buildroot}%{_mandir}/ko/man1/vaclook.1
%{__install} -m644 %{SOURCE19} %{buildroot}%{_mandir}/ko/man1/vacation.1

# manuall milter library
%if %{with_milter}
%{__mkdir_p} %{buildroot}%{sendmailcf}/milter
%{__install} -m644 %{SOURCE21} %{buildroot}%{sendmailcf}/milter/milter-functions
%endif

# libmilter install
%{__install} -m 755 -d %{buildroot}%{_libdir}
%{__install} -m 644  $OBJDIR/libsmutil/libsmutil.a %{buildroot}%{_libdir}
%{__install} -m 644  $OBJDIR/libsm/libsm.a         %{buildroot}%{_libdir}
#if %{with_milter}
#{__install} -m 644  $OBJDIR/libmilter/libmilter.a %{buildroot}%{_libdir}
#endif

# manualy add ruleset in sendmail.cf
#(
#  cd %{buildroot}%{maildir}/
#  perl -pi -e 's!smmsp!mail!g' submit.cf
#  perl -pi -e 's!(O SmtpGreetingMessage=\$j) Sendmail \$v/\$Z; \$b!\1 OopsSMTP \$v-1,2 \$b C=kr!g' *.cf
#)

# install po file
pushd $RPM_BUILD_DIR/%{name}-%{version}/utils-po > /dev/null 2>&1
list=`ls *.po | %{__sed} 's/\.po//g'`
for i in $list
do
  msgfmt $i.po -o $i.mo
  %{__mkdir_p} %{buildroot}/usr/share/locale/$i/LC_MESSAGES
  %{__install} -m644 $i.mo %{buildroot}/usr/share/locale/$i/LC_MESSAGES/sendmail-utils.mo
done
popd > /dev/null 2>&1

strip %{buildroot}%{_sbindir}/{mailstats,praliases,sendmail}
strip %{buildroot}%{_bindir}/makemap

# rename files for alternative usage
%{__mv} %{buildroot}%{_sbindir}/sendmail %{buildroot}%{_sbindir}/sendmail.sendmail
#for i in mailq newaliases rmail; do
for i in mailq newaliases ; do
	%{__mv} %{buildroot}%{_bindir}/$i %{buildroot}%{_bindir}/$i.sendmail
done
%{__mv} %{buildroot}%{_mandir}/man1/mailq.1 %{buildroot}%{_mandir}/man1/mailq.sendmail.1
%{__mv} %{buildroot}%{_mandir}/man1/newaliases.1 %{buildroot}%{_mandir}/man1/newaliases.sendmail.1
%{__mv} %{buildroot}%{_mandir}/man5/aliases.5 %{buildroot}%{_mandir}/man5/aliases.sendmail.5
%{__mv} %{buildroot}%{_mandir}/man8/sendmail.8 %{buildroot}%{_mandir}/man8/sendmail.sendmail.8

%clean
%{__rm} -rf %{buildroot}

%pre
%{_sbindir}/groupmems -g daemon -a mail > /dev/null 2>&1
getent group mailnull > /dev/null || \
  %{_sbindir}/groupadd -g 47 -r mailnull > /dev/null 2>&1
getent passwd mailnull >/dev/null || \
  %{_sbindir}/useradd -u 47 -g mailnull -d %{spooldir}/mqueue -r \
  -s %{smshell} mailnull > /dev/null 2>&1
getent group smmsp >/dev/null || \
  %{_sbindir}/groupadd -g 51 -r smmsp >/dev/null 2>&1
getent passwd smmsp >/dev/null || \
  %{_sbindir}/useradd -u 51 -g smmsp -d %{spooldir}/mqueue -r \
  -s %{smshell} smmsp >/dev/null 2>&1
exit 0

%postun
%systemd_postun_with_restart sendmail.service
if [ "$1" -ge "1" ]; then
    mta=`readlink %{_sysconfdir}/alternatives/mta`
    if [ "$mta" == "%{_sbindir}/sendmail.sendmail" ]; then
        %{_sbindir}/alternatives --set mta %{_sbindir}/sendmail.sendmail
    fi
fi
exit 0

%post
%systemd_post_enable sendmail.service

# Set up the alternatives files for MTAs.
#    --slave %{_bindir}/rmail mta-rmail %{_bindir}/rmail.sendmail \
%{_sbindir}/alternatives --install %{_sbindir}/sendmail mta %{_sbindir}/sendmail.sendmail 90 \
    --slave %{_bindir}/mailq mta-mailq %{_bindir}/mailq.sendmail \
    --slave %{_bindir}/newaliases mta-newaliases %{_bindir}/newaliases.sendmail \
    --slave /usr/lib/sendmail mta-sendmail /usr/lib/sendmail.sendmail \
    --slave %{_sysconfdir}/pam.d/smtp mta-pam %{_sysconfdir}/pam.d/smtp.sendmail \
    --slave %{_mandir}/man8/sendmail.8.gz mta-sendmailman %{_mandir}/man8/sendmail.sendmail.8.gz \
    --slave %{_mandir}/man1/mailq.1.gz mta-mailqman %{_mandir}/man1/mailq.sendmail.1.gz \
    --slave %{_mandir}/man1/newaliases.1.gz mta-newaliasesman %{_mandir}/man1/newaliases.sendmail.1.gz \
    --slave %{_mandir}/man5/aliases.5.gz mta-aliasesman %{_mandir}/man5/aliases.sendmail.5.gz \
    --initscript sendmail

#
# Rebuild maps (next reboot will rebuild also)
#
{ %{_bindir}/newaliases
  for map in virtusertable access domaintable mailertable
  do
	if [ -f %{maildir}/${map} ] ; then
		%{_bindir}/makemap hash %{maildir}/${map} < %{maildir}/${map}
		sleep 1
	fi
  done
} > /dev/null 2>&1

exit 0

%preun
%systemd_preun sendmail.service
if [ $1 = 0 ]; then
   %{_sbindir}/alternatives --remove mta %{_sbindir}/sendmail.sendmail
fi
exit 0

%post milter -p /sbin/ldconfig

%postun milter -p /sbin/ldconfig

%files
%defattr(-,root,root)
#{_sbindir}/make_sendmail_cert
%{_sbindir}/mailstats
%{_sbindir}/praliases
%{_bindir}/hoststat
%{_bindir}/purgestat
#{_bindir}/rmail.sendmail
%{_bindir}/vacation
%{_bindir}/vaclook
%{_sysconfdir}/smrsh/vacation
%{_bindir}/makemap
%{_sbindir}/makemap
%attr(2755,root,smmsp) %{_sbindir}/sendmail.sendmail
%attr(0700,root,root) %{_sbindir}/mapupdate
%{_bindir}/newaliases.sendmail
%{_bindir}/mailq.sendmail
%{_sbindir}/smrsh
/usr/lib/sendmail.sendmail
#{_sysconfdir}/procmailrc

#{_mandir}/man8/rmail.8
%{_mandir}/man8/praliases.8.gz
%{_mandir}/man8/mailstats.8.gz
%{_mandir}/man8/makemap.8.gz
%{_mandir}/man8/sendmail.sendmail.8.gz
%{_mandir}/man5/aliases.sendmail.5.gz
%{_mandir}/man1/newaliases.sendmail.1.gz
%{_mandir}/man1/mailq.sendmail.1.gz
%{_mandir}/man1/vacation.1.gz
%{_mandir}/man1/vaclook.1.gz
%{_mandir}/ko/man1/vacation.1.gz
%{_mandir}/ko/man1/vaclook.1.gz

%defattr(-,root,root)
%{_sysconfdir}/pam.d/smtp.sendmail

/usr/share/locale/ko/LC_MESSAGES/*.mo

%config(noreplace) %verify(not size mtime md5) /var/run/sendmail.st
%{maildir}/helpfile
# XXX can't do noreplace here or new sendmail will not deliver.
%attr(0644,root,root) %config(noreplace) %{maildir}/sendmail.cf
%attr(0644,root,root) %config(noreplace) %{maildir}/submit.cf
%attr(0644,root,root) %config(noreplace) %{maildir}/sendmail.mc
%attr(0644,root,root) %config(noreplace) %{maildir}/submit.mc
%config(noreplace) %{_sysconfdir}/sasl2/Sendmail.conf
%config(noreplace) %{maildir}/local-host-names
%config(noreplace) %{maildir}/aliases
%attr(0644,root,mail) %ghost %{maildir}/aliases.db
%attr(0755,root,mail) %dir %{spooldir}/mqueue
%attr(0770,smmsp,smmsp) %dir %{spooldir}/clientmqueue
%attr(0755,root,mail) %dir %{spooldir}/mqueue/q1
%attr(0755,root,mail) %dir %{spooldir}/mqueue/q2
%attr(0755,root,mail) %dir %{spooldir}/mqueue/q3
%attr(0755,root,mail) %dir %{spooldir}/mqueue/q4
%attr(0755,root,mail) %dir %{spooldir}/mqueue/q5
%attr(0755,root,mail) %dir %{spooldir}/mqueue/q6
%dir %{_sysconfdir}/smrsh
%dir %{maildir}

%{maildir}/Makefile
%attr(0644,root,root) %ghost			%{maildir}/virtusertable.db
%attr(0644,root,root) %config(noreplace)	%{maildir}/virtusertable

%attr(0644,root,root) %ghost			%{maildir}/access.db
%attr(0644,root,root) %config(noreplace)	%{maildir}/access

%attr(0644,root,root) %ghost			%{maildir}/domaintable.db
%attr(0644,root,root) %config(noreplace)	%{maildir}/domaintable

%attr(0644,root,root) %ghost			%{maildir}/mailertable.db
%attr(0644,root,root) %config(noreplace)	%{maildir}/mailertable

%attr(0644,root,root) %config(noreplace)	%{maildir}/smtpauth
%attr(0644,root,root) %config(noreplace)	%{maildir}/trusted-users
%config(noreplace) %{_sysconfdir}/sysconfig/sendmail

%attr(0755, root,root) %{_sbindir}/init.d/sendmail
%attr(0644, root,root) %{_unitdir}/sendmail.service

%files devel
%defattr(-,root,root)
%{_includedir}/sendmail/*.h
%{_libdir}/libsm*.a

%if %{with_milter}
%{_includedir}/libmilter/*.h
%{_libdir}/libmilter.so
%endif

%files milter
%defattr(-,root,root,-)
%{_libdir}/libmilter.so.[0-9].[0-9]
%{_libdir}/libmilter.so.[0-9].[0-9].[0-9]

%files cf
%defattr(-,root,root)
%{sendmailcf}

%files doc
%defattr(-,root,root)
%{_docdir}/sendmail-%{version}

%changelog
* Mon Oct  5 2015 JoungKyun.Kim <http://oops.org> 100:8.15.2-1%{?dist}
- built on AN3

